import bitel.billing.server.phone.bean.*;
import bitel.billing.common.TimeUtils;
import ru.bitel.bgbilling.server.util.ServerUtils;
import ru.bitel.common.Utils;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.util.*;

import java.text.DecimalFormat;
import java.math.BigDecimal;

int mid = 1;//   . : 1

public void fillReport( con, filter, bitel.billing.server.reports.BGCSVReport.ReportResult result )
{
	int hour1 = Utils.parseInt( filter.getStringParam( "hours1" ), 0 );
	int hour2 = Utils.parseInt( filter.getStringParam( "hours2" ), 0 );
	String services = filter.getStringParam( "services" );
	long group = filter.getLongParam( "contractGroups" );
	String working = filter.getStringParam( "working" );
	DecimalFormat dfSumm = new DecimalFormat( "0.00" );	

	Calendar date1 = TimeUtils.convertDateToCalendar( filter.getDateParam( "dateFrom" ) );
	Calendar date2 = TimeUtils.convertDateToCalendar( filter.getDateParam( "dateTo" ) );
	
	date1.set( Calendar.HOUR_OF_DAY, hour1 );
	date2.set( Calendar.HOUR_OF_DAY, hour2 );
	System.out.println( date1 );
	System.out.println( date2 );
	//    
	//    0 
	//
	//    
	StringTokenizer stsid = new StringTokenizer( Utils.maskNull( services ), "," );
	int service_count = stsid.countTokens();
	System.out.println( "  : " + service_count + " " );
	if( service_count > 10 )
	{
		System.out.println( "     10" );
		service_count = 10;
	}
	
    int yy1 = date1.get( Calendar.YEAR );
    int mm1 = date1.get( Calendar.MONTH );	
    int yy2 = date2.get( Calendar.YEAR );
    int mm2 = date2.get( Calendar.MONTH );
    int index = 1;
    
    //   . log_session, session_detail, session_account 
    
    query = "CREATE TABLE IF NOT EXISTS `_kvazar_log_session` (" +
    		" `tid` int(11)," +
    		" `id` int(11)," +
    		" `lid` int(11)," +
    		" `session_start` datetime," +
    		" `session_stop` datetime," +
    		" KEY `tid` (`tid`)," +
    		" KEY `id` (`id`)," +
    		" KEY `lid` (`lid`));";
    		//" KEY `session_start` (`session_start`));";
    con.createStatement().executeUpdate( query );
    
    query = "CREATE TABLE IF NOT EXISTS `_kvazar_session_detail` (" +
    		" `tid` int(11)," +
    		"`session_id` int(11)," +
    		"`sid` int(11)," +
    		"`cid` int(11)," +
    		"`amount` bigint(20)," +
    		" KEY `tid` (`tid`)," +
    		" KEY `sid` (`sid`)," +
    		" KEY `session_id` (`session_id`)" +
    		");";
    con.createStatement().executeUpdate( query );
    
	query = "CREATE TABLE IF NOT EXISTS `_kvazar_session_account` (" +
			" `tid` int(11)," +
			"`session_id` int(11)," +
			"`sid` int(11)," +
			"`cid` int(11)," +
			"`summa` float(10,5)," +
    		" KEY `tid` (`tid`)," +
    		" KEY `sid` (`sid`)," +
    		" KEY `session_id` (`session_id`)" +
			");";
	con.createStatement().executeUpdate( query );
    
    //     
    
    String tmpLogSession = insert_tb( con, mm1, yy1, mm2, yy2, "log_session", "id, lid, session_start, session_stop", "", "session_start", date1, date2 );
    String tmpDetail = "_kvazar_detail";
    String tmpAccount = "_kvazar_account";
    
    if( Utils.isBlankString( tmpLogSession ) )
    {
    	//         
    	//showMessageDialog( "    !" );
    	return;
    }
    
	if( !working.equals("1") )
	{
	    String tmpSessionDetail = insert_tb( con, mm1, yy1, mm2, yy2, "session_detail", "session_id, sid, cid, amount", "", "", date1, date2 );
	    String tmpSessionAccount = insert_tb( con, mm1, yy1, mm2, yy2, "session_account", "session_id, sid, cid, summa", "", "", date1, date2 );
	    
	    //_kvazar_detail
	    
	    System.out.println( " :'" + tmpDetail + "'" );
	    ServerUtils.dropExistTable( con, tmpDetail );
		System.out.println( " " );
	    
		query = "CREATE TABLE IF NOT EXISTS `" + tmpDetail + "` (" +
		" `lid` int(11)," +
		" `sid` int(11)," +
		" `title` varchar(250)," +
		" `amount` bigint(20)," +
		" UNIQUE(lid,sid)" +
		");";
		System.out.println( query );
		con.createStatement().executeUpdate( query );
		System.out.println( " " );
		
		/*
		query = "DELETE FROM " + tmpDetail + ";";
		System.out.println( query );
		con.createStatement().executeUpdate( query );
		System.out.println( " " );
		*/
		
	    query = "INSERT INTO " + tmpDetail + " ( lid, sid, title, amount ) " +
		" SELECT lid, detail.sid, service.title, sum(detail.amount) AS amount FROM " +
		tmpLogSession + " session" +
		" LEFT JOIN " + tmpSessionDetail + " detail ON detail.session_id = session.id AND detail.tid = session.tid" +
		" LEFT JOIN service ON detail.sid = service.id" +
		//" WHERE session.session_start>=? AND session.session_start<=?" +
		" GROUP BY session.lid, detail.sid;";
	    
		ps = con.prepareStatement( query );
		//index = 1;
		//ps.setTimestamp( index++, TimeUtils.convertCalendarToTimestamp( date1 ) );
		//ps.setTimestamp( index++, TimeUtils.convertCalendarToTimestamp( date2 ) );
		System.out.println( query );
		ps.executeUpdate();
		System.out.println( " " );
		
		//_kvazar_account
	    System.out.println( " :'" + tmpAccount + "'" );
	    ServerUtils.dropExistTable( con, tmpAccount );
	    System.out.println( " " );
	    
		query = "CREATE TABLE IF NOT EXISTS `" + tmpAccount + "` (" +
		" `lid` int(11)," +
		" `sid` int(11)," +
		" `title` varchar(250)," +
		" `summa` float(10,5)," +
		" UNIQUE(lid,sid)" +
		");";
		System.out.println( query );
		con.createStatement().executeUpdate( query );
		System.out.println( " " );
		/*
		query = "DELETE FROM " + tmpAccount + ";";
		System.out.println( query );
		con.createStatement().executeUpdate( query );
		System.out.println( " " );
		*/
	    query = "INSERT INTO " + tmpAccount  + "  (lid, sid, title, summa ) " +
		" SELECT lid, account.sid, service.title, ROUND(sum(account.summa),2) AS summa FROM " +
		tmpLogSession + " session" +
		" LEFT JOIN " + tmpSessionAccount + " account ON account.session_id = session.id AND account.tid = session.tid" +
		" LEFT JOIN service ON account.sid = service.id" +
		//" WHERE session.session_start>=? AND session.session_start<=?" +
		" GROUP BY session.lid, account.sid;";
	    
		ps = con.prepareStatement( query );
		//index = 1;
		//ps.setTimestamp( index++, TimeUtils.convertCalendarToTimestamp( date1 ) );
		//ps.setTimestamp( index++, TimeUtils.convertCalendarToTimestamp( date2 ) );
	
		System.out.println( query );
		ps.executeUpdate();	
		System.out.println( " " );
	}
   	//alias_of_logins
	query = "DROP TEMPORARY TABLE IF EXISTS temp_alias;";  	
	con.createStatement().executeUpdate( query );
	System.out.println( query );
 
	query = "CREATE TEMPORARY TABLE temp_alias ( UNIQUE(lid) ) " +
			" SELECT ua.login_id AS lid, ua.login_alias AS alias" +
			" FROM user_alias_" + mid + " ua " +
			" GROUP BY ua.login_id";
	
	System.out.println( query );
	con.createStatement().executeUpdate( query );
	System.out.println( " " );
   	//--------------
   	
   	//temp_tariff
	query = "DROP TEMPORARY TABLE IF EXISTS temp_tariff;";  	
	con.createStatement().executeUpdate( query );
	System.out.println( query );
 
	query = "CREATE TEMPORARY TABLE temp_tariff ( UNIQUE(cid) ) " +
			" SELECT contract_tariff.cid AS cid, GROUP_CONCAT(tp.title) AS tariffs" +
			" FROM contract_tariff" +
			" LEFT JOIN tariff_plan tp ON contract_tariff.tpid=tp.id" +
			" WHERE	contract_tariff.date1<? AND (contract_tariff.date2>? OR contract_tariff.date2 IS NULL)" +
			" GROUP BY contract_tariff.cid";
	
	System.out.println( query );
	ps = con.prepareStatement( query );
	
	index = 1;
	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( date1 ) );
	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( date2 ) );
	
   	ps.executeUpdate();
   	//--------------
   	// 
	query = "DROP TEMPORARY TABLE IF EXISTS temp_balance1;";  	
	con.createStatement().executeUpdate( query );
	System.out.println( query );
 
	query = "CREATE TEMPORARY TABLE temp_balance1 ( UNIQUE(cid) ) " +
			" SELECT cb.cid AS cid, cb.summa1 - COALESCE(sum(cc.summa),0) + COALESCE(sum(cp.summa),0) AS summa" +
			" FROM contract_balance cb" +
			" LEFT JOIN contract_charge cc on cc.cid = cb.cid and cc.dt>=? and cc.dt<=?" +
			" LEFT JOIN contract_payment cp on cp.cid = cb.cid and cp.dt>=? and cp.dt<=?" +
			" WHERE	cb.yy=? and cb.mm=?" +
			" GROUP BY cb.cid";
	
	System.out.println( query );
	ps = con.prepareStatement( query );
	
	int index = 1;
    Calendar monthStart = new GregorianCalendar();
	monthStart.set( yy1, mm1, 1 );
	
	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( monthStart ) );
	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( date1 ) );
	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( monthStart ) );
	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( date1 ) );
	ps.setInt( index++, yy1 );
	ps.setInt( index++, mm1 + 1 );
	
   	ps.executeUpdate();
   	//------------
   	// 
	query = "DROP TEMPORARY TABLE IF EXISTS temp_balance2;";  	
	con.createStatement().executeUpdate( query );
	System.out.println( query );
 
	query = "CREATE TEMPORARY TABLE temp_balance2 ( UNIQUE(cid) ) " +
			" SELECT cb.cid AS cid, cb.summa1 - COALESCE(sum(cc.summa),0) + COALESCE(sum(cp.summa),0) AS summa" +
			" FROM contract_balance cb" +
			" LEFT JOIN contract_charge cc on cc.cid = cb.cid and cc.dt>=? and cc.dt<=?" +
			" LEFT JOIN contract_payment cp on cp.cid = cb.cid and cp.dt>=? and cp.dt<=?" +
			" WHERE	cb.yy=? and cb.mm=?" +
			" GROUP BY cb.cid";
	
	System.out.println( query );
	ps = con.prepareStatement( query );
	
	int index = 1;
    monthStart = new GregorianCalendar();
	monthStart.set( yy2, mm2, 1 );
	
	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( monthStart ) );
	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( date2 ) );
	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( monthStart ) );
	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( date2 ) );
	ps.setInt( index++, yy2 );
	ps.setInt( index++, mm2 + 1 );
	
   	ps.executeUpdate();
   	//------------
   	//
	query = "DROP TEMPORARY TABLE IF EXISTS temp_payment;";  	
	con.createStatement().executeUpdate( query );
	System.out.println( query );
 
	query = "CREATE TEMPORARY TABLE temp_payment ( UNIQUE(cid) ) " +
	" SELECT cp.cid AS cid, SUM(cp.summa) AS summa" +
	" FROM contract_payment cp" +
	" WHERE	cp.dt>=? AND cp.dt<=?" +
	" GROUP BY cp.cid";
	
	System.out.println( query );
	ps = con.prepareStatement( query );
	
	int index = 1;
	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( date1 ) );
	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( date2 ) );
	
   	ps.executeUpdate();
   	//------------
   	// 
   	//   1.
	query = "DROP TEMPORARY TABLE IF EXISTS temp_charge;";  	
	con.createStatement().executeUpdate( query );
	System.out.println( query );
 
	query = "CREATE TEMPORARY TABLE temp_charge ( UNIQUE(cid) ) " +
			" SELECT cc.cid AS cid, SUM(cc.summa) AS summa" +
			" FROM contract_charge cc" +
			" WHERE	cc.dt>=? AND cc.dt<=? AND cc.pt=1" +
			" GROUP BY cc.cid";
	
	System.out.println( query );
	ps = con.prepareStatement( query );
	
	index = 1;
	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( date1 ) );
	ps.setDate( index++, TimeUtils.convertCalendarToSqlDate( date2 ) );
	
   	ps.executeUpdate();
   	//------------
   	// 
	if( !working.equals("1") )
	{
		query = "DROP TEMPORARY TABLE IF EXISTS temp_work;";  	
		con.createStatement().executeUpdate( query );
		System.out.println( query );
	 
		query = "CREATE TEMPORARY TABLE temp_work ( UNIQUE(lid) ) " +
				" SELECT ka.lid AS lid, SUM(ka.summa) AS summa" +
				" FROM " + tmpAccount + " ka" +
				" GROUP BY ka.lid";
		
		System.out.println( query );
		ps = con.prepareStatement( query );
	   	ps.executeUpdate();
	}
   	//------------
   	// 
    String tmpLogins = "_kvazar_work_logins";
    String tmpContracs = "_kvazar_work_contracts";
    String joinLogins = "";
   	if( working.equals("0") || working.equals("2") )
   	{
	    ServerUtils.dropExistTable( con, tmpLogins );
	
	    query = "CREATE TEMPORARY TABLE " + tmpLogins  + " ( UNIQUE(lid) ) " +
		" SELECT DISTINCT lid FROM " +
		tmpLogSession + " session ";
	    
		ps = con.prepareStatement( query );
		System.out.println( query );
		ps.executeUpdate();
		if(working.equals("0"))
		{ 
			joinLogins = " INNER JOIN " + tmpLogins + " ON " + tmpLogins + ".lid = ul.id ";
		}
		if(working.equals("2"))
		{ 
			joinLogins = " LEFT OUTER JOIN " + tmpLogins + " ON " + tmpLogins + ".lid = ul.id ";
		}

   	}
   	else if( working.equals("1") )
   	{
	    ServerUtils.dropExistTable( con, tmpContracs );
		
	    query = "CREATE TEMPORARY TABLE " + tmpContracs  + " ( UNIQUE(cid) ) " +
		" SELECT DISTINCT ul.cid FROM " +
		tmpLogSession + " session" +
		" LEFT JOIN user_login_" + mid + " ul ON ul.id = session.lid";
	    
		ps = con.prepareStatement( query );
		System.out.println( query );
		ps.executeUpdate();
   	}
   	//---------------
	String sidjoin = "";
	String sidfield = "";
	String sidjoin_a = "";
	String sidfield_a = "";
	index = 1;
	while( stsid.hasMoreTokens() && index <= 10 )
	{
		String sid = stsid.nextToken().trim();
		String tbDetail = "detail" + index;
		String tbAccount = "account" + index++;
		sidjoin += " LEFT JOIN " + tmpDetail + " " + tbDetail + " ON ul.id = " + tbDetail + ".lid AND "+ tbDetail + ".sid = "+ sid;
		sidfield += ", "+ tbDetail + ".sid, "+ tbDetail + ".title, COALESCE("+ tbDetail + ".amount,0) AS " + tbDetail + "amount ";
		sidjoin_a += " LEFT JOIN " + tmpAccount + " " + tbAccount + " ON ul.id = " + tbAccount + ".lid AND "+ tbAccount + ".sid = "+ sid;
		sidfield_a += ", COALESCE("+ tbAccount + ".summa,0) " + tbAccount + "summa ";
		//sidwhere += " AND "+ tbDetail + ".sid = "+ sid;
	}
	System.out.println( sidjoin );
	System.out.println( sidfield );
	
	if(!working.equals("1") )
	{
		query = "SELECT c.id, ul.login, temp_alias.alias, c.title, c.status, param_client.val, param_address.address, param_phone.val," +
				" temp_tariff.tariffs, COALESCE(temp_payment.summa,0) AS tpsumma, COALESCE(temp_charge.summa,0) AS tcsumma, COALESCE(temp_balance1.summa,0) AS tb1summa," +
				" COALESCE(temp_balance2.summa,0) AS tb2summa, COALESCE(temp_work.summa,0) AS twsumma " + 
		sidfield + sidfield_a +
		" FROM user_login_" + mid + " ul " +
		joinLogins + sidjoin + sidjoin_a +
		" LEFT JOIN contract c ON c.id=ul.cid" +
		" LEFT JOIN contract_parameter_type_1 param_client ON param_client.cid=c.id AND param_client.pid=13" +
		" LEFT JOIN contract_parameter_type_2 param_address ON param_address.cid=c.id AND param_address.pid=15" +
		" LEFT JOIN contract_parameter_type_1 param_phone ON param_phone.cid=c.id AND param_phone.pid=3" +
		" LEFT JOIN temp_tariff ON temp_tariff.cid=c.id " + 
		" LEFT JOIN temp_payment ON temp_payment.cid = c.id " +
		" LEFT JOIN temp_charge ON temp_charge.cid = c.id " +
		" LEFT JOIN temp_balance1 ON temp_balance1.cid = c.id" +
		" LEFT JOIN temp_balance2 ON temp_balance2.cid = c.id" +
		" LEFT JOIN temp_work ON ul.id = temp_work.lid" +
		" LEFT JOIN temp_alias ON temp_alias.lid = ul.id" +
		" WHERE 1>0";
	}
	else
	{
		query = "SELECT c.id, c.title, c.status, param_client.val, param_address.address, param_phone.val," +
		" temp_tariff.tariffs, COALESCE(temp_payment.summa,0) AS tpsumma, COALESCE(temp_charge.summa,0) AS tcsumma, COALESCE(temp_balance1.summa,0) AS tb1summa," +
		" COALESCE(temp_balance2.summa,0) AS tb2summa " + 
		" FROM contract c " +
		" INNER JOIN (select distinct cid from user_login_" + mid +" ) ul ON ul.cid = c.id "+
		" LEFT OUTER JOIN " + tmpContracs + " tc ON tc.cid = c.id" +
		" LEFT JOIN contract_parameter_type_1 param_client ON param_client.cid=c.id AND param_client.pid=13" +
		" LEFT JOIN contract_parameter_type_2 param_address ON param_address.cid=c.id AND param_address.pid=15" +
		" LEFT JOIN contract_parameter_type_1 param_phone ON param_phone.cid=c.id AND param_phone.pid=3" +
		" LEFT JOIN temp_tariff ON temp_tariff.cid=c.id " + 
		" LEFT JOIN temp_payment ON temp_payment.cid = c.id " +
		" LEFT JOIN temp_charge ON temp_charge.cid = c.id " +
		" LEFT JOIN temp_balance1 ON temp_balance1.cid = c.id" +
		" LEFT JOIN temp_balance2 ON temp_balance2.cid = c.id" +
		" WHERE tc.cid is null ";	
	}
	if( group > 0 )
	{
		query += " AND (c.gr & ?) > 0 ";
	}
	if( working.equals("2") )
	{
		query += " AND " + tmpLogins + ".lid is null ";
	}

	System.out.println( query );
	ps = con.prepareStatement( query );
	
	if( group > 0 )
	{
		ps.setLong( 1, group );
	}
	System.out.println( query );
	data = new ArrayList( 1000 );
	rs = ps.executeQuery();
	int i = 1;
	while( rs.next() )
	{
		map = new HashMap();
		//System.out.println( String.valueOf(i++) );
		map.put( "cid", rs.getString( "c.id" ) );
		//System.out.println( String.valueOf(rs.getInt( "ul.cid" )) );
		map.put( "contractTitle", rs.getString( "c.title" ) );
		//System.out.println( rs.getString( "c.title" ) );
		map.put( "client", rs.getString( "param_client.val" ) );
		//System.out.println( rs.getString( "param_client.val" ) );
		map.put( "contactPhone", rs.getString( "param_phone.val" ) );
		//System.out.println( rs.getString( "param_phone.val" ) );
		map.put( "RegAddress", rs.getString( "param_address.address" ) );
		//System.out.println( rs.getString( "param_address.address" ) );
		String state = "";
		switch ( rs.getInt( "c.status" ) )
		{
			case 0: state = ""; break; 
			case 1: state = " "; break; 
			case 2: state = ""; break; 
			case 3: state = ""; break; 
			case 4: state = ""; break;
			case 5: state = " "; 
		}

		map.put( "state", state );
		//System.out.println( rs.getString( "c.status" ) );
		/*
		 *  : 0 - , 1 -  , 2 - , 3 - , 4 - , 5 -  */
		map.put( "tariff", rs.getString( "temp_tariff.tariffs" ) );
		map.put( "bfbalance", dfSumm.format( rs.getBigDecimal( "tb1summa" ) ) );
		map.put( "incoming", dfSumm.format( rs.getBigDecimal( "tpsumma" ) ) );
		map.put( "abonpay", dfSumm.format( rs.getBigDecimal( "tcsumma" ) ) );
		map.put( "cfbalance", dfSumm.format( rs.getBigDecimal( "tb2summa" ) ) );


		if( !working.equals("1") )
		{
			map.put( "login", rs.getString( "temp_alias.alias" ) );
			map.put( "work", dfSumm.format( rs.getBigDecimal( "twsumma" ) ) );
			for( i = 1; i <= service_count; i++ )
			{
				String snumber = String.valueOf(i);
				double amount = (double)rs.getLong( "detail" + snumber + "amount" ) / 1048576;
				map.put( "service" + snumber + "v", String.valueOf( amount ).replace(".",",") );
				//System.out.println( "Djn " + snumber + ": " + rs.getString( "detail" + snumber + ".amount" ) );
				map.put( "service" + snumber + "n", rs.getString( "account" + snumber + "summa" ).replace(".",",") );
			}
		}
		
		data.add( map );
	}
	result.setData( data );
}

/**
 *          .
 */
private String insert_tb( Connection con, int mm1, int yy1, int mm2, int yy2, String tb, String cols, String index, String datecolumn, Calendar date1, Calendar date2 )
{
    String query = null;
    PreparedStatement ps = null;

    boolean existTraffic = false;
    
    Calendar monthId = new GregorianCalendar();
	monthId.set( yy1, mm1, 1 );
    
    int cyy = yy1;
    int cmm = mm1 + 1; //    0,  + 1
    
    int count = 0;
    int i = ( yy1 == yy2 ) ? ( mm2 - mm1 ) : ( ( yy2 - yy1 ) * 12 + ( mm2 - mm1 ) );
    String tmpTb = "_kvazar_" + tb;
    //ServerUtils.dropExistTable( con, tmpTb );
    
	query = "DELETE FROM " + tmpTb + ";";  	
	con.createStatement().executeUpdate( query );
	System.out.println( query );
    
    //query = "CREATE TABLE " + tmpTb + " (UNIQUE(cid, sid, tid))" +

    query = "INSERT INTO " + tmpTb + " ( tid, " + cols + ") " +
	" SELECT tid, " + cols + " FROM (";
    /*         ,   
     * int i = (yy1==yy2) ? (mm2-mm1):((yy2-yy1)*12 + (mm2-mm1));
     *    ,      union all.
     */
    for( i; i >= 0; i-- )
    {
    	String monthTable = tb +"_" + mid + "_" + cyy + (( cmm < 10 ) ? ( "0" + cmm ) : cmm) ;
    	System.out.println( String.valueOf(i) + ":  :" + cmm + "-" + cyy + ". Table: '" + monthTable + "'" );
    	if( !ServerUtils.tableExists( con, monthTable ) )
    	{
    		//  
    		System.out.println( "    ."  );
        	cmm += cmm < 12 ? 1 : -11;
        	cyy += cmm == 1 ? 1 : 0;
    		continue;
    	}
    	System.out.println( " ."  );
    	existTraffic = true;
    	count++;
    	
    	if( Utils.isBlankString(datecolumn) )
    	{
    		query += " SELECT " + cyy + cmm + " as tid, " + cols +
    		" FROM " + monthTable + " ";
    	}
    	else
    	{
    		query += " SELECT " + cyy + cmm + " as tid, " + cols +
    		" FROM " + monthTable + " WHERE " + datecolumn + ">=? AND " + datecolumn + "<=?";
    	}
    	
    	query += i > 0 ? " UNION ALL" : "";    	
    	
    	//  
    	cmm += cmm < 12 ? 1 : -11;
    	cyy += cmm == 1 ? 1 : 0;
    }

	query = query.replaceFirst( "UNION ALL$", "" );
    query += " ) AS tmptb;";
	System.out.println( query );
	
	if( !existTraffic )
	{
		return "";
	}
	
	ps = con.prepareStatement( query );

	if( Utils.notBlankString(datecolumn) )
	{
		int index = 1;
	    for( i = 1; i <= count; i++ )
	    {
	    	ps.setTimestamp( index++, TimeUtils.convertCalendarToTimestamp( date1 ) );
	    	ps.setTimestamp( index++, TimeUtils.convertCalendarToTimestamp( date2 ) );
	    }
	}

	System.out.println( query );
	ps.executeUpdate();
	System.out.println( " :'" + tmpTb + "'" );
	return tmpTb;
}
